## quick-lint-js-3.2.0.tar.gz

=== CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
if (POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif ()

file(READ version QUICK_LINT_JS_VERSION)
string(REGEX MATCH "^[^\n]+" QUICK_LINT_JS_VERSION "${QUICK_LINT_JS_VERSION}")

project(quick-lint-js)

include(GNUInstallDirs)

option(QUICK_LINT_JS_ENABLE_BENCHMARKS "Build microbenchmark programs" OFF)
option(QUICK_LINT_JS_ENABLE_VSCODE "Build VS Code extension bits" OFF)

set(QUICK_LINT_JS_ENABLE_CLI_DEFAULT ON)
if (EMSCRIPTEN)
  set(QUICK_LINT_JS_ENABLE_CLI_DEFAULT OFF)
endif ()
option(
  QUICK_LINT_JS_ENABLE_CLI
  "Build the command-line program and LSP server"
  "${QUICK_LINT_JS_ENABLE_CLI_DEFAULT}"
)

set(
  QUICK_LINT_JS_USE_BUILD_TOOLS
  ""
  CACHE
  PATH
  "Directory containing tools built by the quick-lint-js-code-gen-tools target. See http://quick-lint-js.com/contribute/build-from-source/cross-compiling/ for details."
)

set(QUICK_LINT_JS_ENABLE_BUILD_TOOLS_DEFAULT ON)
if (QUICK_LINT_JS_USE_BUILD_TOOLS OR EMSCRIPTEN OR CMAKE_CROSSCOMPILING)
  set(QUICK_LINT_JS_ENABLE_BUILD_TOOLS_DEFAULT OFF)
endif ()
option(
  QUICK_LINT_JS_ENABLE_BUILD_TOOLS
  "Compile tools which generate quick-lint-js source code and use them during the build"
  "${QUICK_LINT_JS_ENABLE_BUILD_TOOLS_DEFAULT}"
)

if (EMSCRIPTEN)
  # TODO(strager): Require QUICK_LINT_JS_USE_BUILD_TOOLS or
  # QUICK_LINT_JS_ENABLE_BUILD_TOOLS for Emscripten builds.
else ()
  if (NOT (QUICK_LINT_JS_USE_BUILD_TOOLS OR QUICK_LINT_JS_ENABLE_BUILD_TOOLS))
    set(MESSAGE "Neither QUICK_LINT_JS_USE_BUILD_TOOLS nor QUICK_LINT_JS_ENABLE_BUILD_TOOLS was specified.")
    if (CMAKE_CROSSCOMPILING OR EMSCRIPTEN)
      set(MESSAGE "${MESSAGE} QUICK_LINT_JS_ENABLE_BUILD_TOOLS was automatically disabled because you are cross-compiling.")
    endif ()
    set(MESSAGE "${MESSAGE} You should configure with QUICK_LINT_JS_ENABLE_BUILD_TOOLS=YES for your build machine and build quick-lint-js-build-tools,")
    set(MESSAGE "${MESSAGE} then you should separately configure with QUICK_LINT_JS_USE_BUILD_TOOLS=(path to your first build) for your target machine.")
    set(MESSAGE "${MESSAGE} See this cross-compiling documentation for details: https://quick-lint-js.com/contribute/build-from-source/cross-compiling/")
    message(FATAL_ERROR "${MESSAGE}")
  endif ()
endif ()

if (QUICK_LINT_JS_ENABLE_BUILD_TOOLS AND QUICK_LINT_JS_USE_BUILD_TOOLS)
  message(FATAL_ERROR "QUICK_LINT_JS_ENABLE_BUILD_TOOLS and QUICK_LINT_JS_USE_BUILD_TOOLS were both specified, but are mutually exclusive. If QUICK_LINT_JS_USE_BUILD_TOOLS (${QUICK_LINT_JS_USE_BUILD_TOOLS}) is intended, set QUICK_LINT_JS_ENABLE_BUILD_TOOLS=NO.")
endif ()

if (${CMAKE_VERSION} VERSION_GREATER_EQUAL 3.17.3)
  option(QUICK_LINT_JS_PRECOMPILE_HEADERS "Use CMake's target_precompile_headers" ON)
else ()
  set(QUICK_LINT_JS_PRECOMPILE_HEADERS FALSE)
endif ()

set(
  QUICK_LINT_JS_INSTALL_EMACS_DIR
  "${CMAKE_INSTALL_DATAROOTDIR}/emacs/site-lisp"
  CACHE
  STRING
  "Install Emacs Lisp files into this directory relative to CMAKE_INSTALL_PREFIX"
)
set(
  QUICK_LINT_JS_INSTALL_LICENSES_DIR
  "${CMAKE_INSTALL_DOCDIR}"
  CACHE
  STRING
  "Install licenses into this directory relative to CMAKE_INSTALL_PREFIX"
)
set(
  QUICK_LINT_JS_INSTALL_NEOVIM_DIR
  "${CMAKE_INSTALL_DATAROOTDIR}/nvim/site"
  CACHE
  STRING
  "Install Neovim files into this directory relative to CMAKE_INSTALL_PREFIX"
)
set(
  QUICK_LINT_JS_INSTALL_VIM_DIR
  "${CMAKE_INSTALL_DATAROOTDIR}/vim/vimfiles"
  CACHE
  STRING
  "Install Vim files into this directory relative to CMAKE_INSTALL_PREFIX"
)
option(
  QUICK_LINT_JS_INSTALL_VIM_NEOVIM_TAGS
  "Install a 'tags' file with Vim and Neovim documentation"
  OFF
)

option(
  QUICK_LINT_JS_USE_BUNDLED_GOOGLE_BENCHMARK
  "Use the third-party Google Benchmark library bundled with quick-lint-js instead of using the host-installed Google Benchmark"
  ON
)
option(
  QUICK_LINT_JS_USE_BUNDLED_GOOGLE_TEST
  "Use the third-party Google Test library bundled with quick-lint-js instead of using the host-installed Google Test"
  ON
)
option(
  QUICK_LINT_JS_USE_BUNDLED_SIMDJSON
  "Use the third-party simdjson library bundled with quick-lint-js instead of using the host-installed simdjson"
  ON
)

option(
  QUICK_LINT_JS_FEATURE_DEBUG_SERVER
  "Enable the HTTP monitoring server at run-time"
  FALSE
)
option(
  QUICK_LINT_JS_FEATURE_EXTRA_DEBUG
  "Enable extra slow debug checking at run-time"
  FALSE
)
option(
  QUICK_LINT_JS_FEATURE_VECTOR_PROFILING
  "Enable the QLJS_DUMP_VECTORS option at run-time"
  FALSE
)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(QuickLintJSCompiler)

quick_lint_js_set_cxx_standard()
quick_lint_js_enable_char8_t_if_supported()
quick_lint_js_configure_exception_handling()
quick_lint_js_configure_rtti()
quick_lint_js_work_around_implicit_link_directories()
quick_lint_js_work_around_precompiled_headers_pic_pie_conflict()
quick_lint_js_enable_dead_code_stripping()
quick_lint_js_disable_unwanted_warnings()

if (WIN32)
  add_definitions(-D_WIN32_WINNT=0x0602)
endif ()
if (QUICK_LINT_JS_FEATURE_EXTRA_DEBUG)
  add_compile_definitions(QLJS_DEBUG)
endif ()

# HACK(strager): Work around issues with CI. We should consider using
# find_package(Python3) instead.
find_package(PythonInterp 3.7)

find_package(PythonInterp 3)  # Force Python 3 (instead of Python 2).

# quick-lint-js-precompiled-headers is used by quick_lint_js_add_executable and
# quick_lint_js_add_library.
include(QuickLintJSTarget)
find_package(Threads REQUIRED)
quick_lint_js_add_empty_cxx_library(quick-lint-js-precompiled-headers)
target_link_libraries(
  quick-lint-js-precompiled-headers
  PUBLIC
  Threads::Threads
  simdjson
)
if (QUICK_LINT_JS_PRECOMPILE_HEADERS)
  target_precompile_headers(
    quick-lint-js-precompiled-headers
    PUBLIC
    <cmath>
    <cstring>
    <simdjson.h>
    <string>
  )
endif ()

# 'tools' must come first because it optionally defines targets. Other
# CMakeLists.txt files detect the presence of these targets.
add_subdirectory(tools)

if (QUICK_LINT_JS_ENABLE_BENCHMARKS)
  include(vendor/benchmark.cmake)
endif ()
include(vendor/googletest.cmake)
if (QUICK_LINT_JS_FEATURE_DEBUG_SERVER)
  include(vendor/mongoose.cmake)
endif ()
include(vendor/node-addon-api.cmake)
include(vendor/node.cmake)
include(vendor/simdjson.cmake)

if (QUICK_LINT_JS_ENABLE_BENCHMARKS)
  add_subdirectory(benchmark)
endif ()
add_subdirectory(dist)
add_subdirectory(docs)
add_subdirectory(fuzz)
add_subdirectory(plugin/vim)
add_subdirectory(plugin/emacs)
add_subdirectory(plugin/vscode)
add_subdirectory(src)
add_subdirectory(website/wasm)
add_subdirectory(completions)
include(CTest)
if (BUILD_TESTING)
  add_subdirectory(test)
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== benchmark/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(QuickLintJSTarget)

add_subdirectory(benchmark-lsp)

function (quick_lint_js_add_benchmark_executable TARGET_NAME)
  set(SOURCES "${ARGN}")
  quick_lint_js_add_executable("${TARGET_NAME}" ${SOURCES})
  target_link_libraries(
    "${TARGET_NAME}"
    PRIVATE
    benchmark::benchmark
    benchmark::benchmark_main
    quick-lint-js-benchmark-support
    quick-lint-js-lib
  )
  if (EMSCRIPTEN)
    # Enable --benchmark-out when running with Node.js.
    target_link_libraries("${TARGET_NAME}" PRIVATE -sNODERAWFS=1)
  endif ()
endfunction ()

quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-cli-location
  benchmark-cli-location.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-configuration
  benchmark-configuration.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-configuration-loader
  benchmark-configuration-loader.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-lex
  benchmark-lex.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-lint
  benchmark-lint.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-lsp
  benchmark-lsp.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-lsp-document-text
  benchmark-lsp-document-text.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-lsp-location
  benchmark-lsp-location.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-parse
  benchmark-parse.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-translation
  benchmark-translation.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-utf-8
  benchmark-utf-8.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-vector-profiler
  benchmark-vector-profiler.cpp
)
target_link_libraries(
  quick-lint-js-benchmark-vector-profiler
  PRIVATE
  quick-lint-js-lib-debug
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-vim-location
  benchmark-vim-location.cpp
)

quick_lint_js_add_library(
  quick-lint-js-benchmark-support
  generate-code.cpp
  quick-lint-js/generate-code.h
)
target_include_directories(quick-lint-js-benchmark-support PUBLIC .)
target_link_libraries(quick-lint-js-benchmark-support PUBLIC quick-lint-js-lib)

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== completions/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(GNUInstallDirs)

# zsh on Arch Linux and on Homebrew on macOS search in this path:
install(
  FILES _quick-lint-js
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/zsh/site-functions"
)
# zsh on Linux Mint searches in this path:
install(
  FILES _quick-lint-js
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/zsh/vendor-completions"
)

install(
  FILES quick-lint-js.bash
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/bash-completion/completions"
)

install(
  FILES quick-lint-js.fish
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/fish/vendor_completions.d"
)

install(
  FILES quick-lint-js.ps1
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/powershell/completions"
)

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== dist/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(GNUInstallDirs)

# Install AppStream files to /usr/share/metainfo/%{id}.metainfo.xml.
# https://www.freedesktop.org/software/appstream/docs/chap-Quickstart.html
install(
  FILES appstream/com.quick_lint.quick_lint_js.metainfo.xml
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
)

# Install icons referenced by the AppStream metadata.
install(
  FILES artwork/dusty-right.svg
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps"
  RENAME com.quick_lint.quick_lint_js.svg
)

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== docs/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(GNUInstallDirs)

install(
  FILES man/quick-lint-js.1
  DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
)
install(
  FILES man/quick-lint-js.config.5
  DESTINATION "${CMAKE_INSTALL_MANDIR}/man5"
)
install(
  FILES man/quick-lint-js-lsp.8
  DESTINATION "${CMAKE_INSTALL_MANDIR}/man8"
)

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== fuzz/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(QuickLintJSTarget)

option(QUICK_LINT_JS_ENABLE_LLVM_LIBFUZZER_TESTS "" OFF)

if (QUICK_LINT_JS_ENABLE_LLVM_LIBFUZZER_TESTS)
  function (quick_lint_js_add_fuzz_executable TARGET)
    quick_lint_js_add_executable("${TARGET}" ${ARGN})
    target_compile_options("${TARGET}" PRIVATE -fsanitize=fuzzer-no-link)
    target_link_libraries("${TARGET}" PRIVATE -fsanitize=fuzzer)
  endfunction ()

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-configuration-json fuzz-configuration-json.cpp)
  target_link_libraries(quick-lint-js-fuzz-configuration-json PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-lex fuzz-lex.cpp)
  target_link_libraries(quick-lint-js-fuzz-lex PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-lsp-server fuzz-lsp-server.cpp)
  target_link_libraries(quick-lint-js-fuzz-lsp-server PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-lsp-message-parser fuzz-lsp-message-parser.cpp)
  target_link_libraries(quick-lint-js-fuzz-lsp-message-parser PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-options fuzz-options.cpp)
  target_link_libraries(quick-lint-js-fuzz-options PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-parse fuzz-parse.cpp)
  target_link_libraries(quick-lint-js-fuzz-parse PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-parse-lint fuzz-parse-lint.cpp)
  target_link_libraries(quick-lint-js-fuzz-parse-lint PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-utf-8-decode-encode fuzz-utf-8-decode-encode.cpp)
  target_link_libraries(quick-lint-js-fuzz-utf-8-decode-encode PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-utf-8-lsp fuzz-utf-8-lsp.cpp)
  target_link_libraries(quick-lint-js-fuzz-utf-8-lsp PRIVATE quick-lint-js-lib)
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== src/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(GNUInstallDirs)
include(QuickLintJSCompiler)
include(QuickLintJSCopyright)
include(QuickLintJSTarget)

find_package(Threads REQUIRED)

if (QUICK_LINT_JS_ENABLE_CLI)
  set(EXTRA_SOURCES)
  if (WIN32)
    list(APPEND EXTRA_SOURCES quick-lint-js/cli/quick-lint-js.rc)
    # TODO(strager): Add a dependency on dusty-icon.ico which is referenced by
    # quick-lint-js.rc.
  endif ()
  quick_lint_js_add_executable(
    quick-lint-js
    quick-lint-js/cli/main.cpp
    ${EXTRA_SOURCES}
  )
  set_target_properties(quick-lint-js PROPERTIES RUNTIME_OUTPUT_DIRECTORY ..)
  target_link_libraries(quick-lint-js PRIVATE quick-lint-js-lib)
  quick_lint_js_enable_windows_unicode(quick-lint-js)

  # TODO(strager): Use the default DESTINATION for CMake versions which have a
  # default. (3.18.0 has a default; 3.12.4 doesn't have a default.)
  install(TARGETS quick-lint-js RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif ()

if (TARGET quick-lint-js-generate-diagnostic-metadata)
  add_custom_command(
    OUTPUT
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-metadata-generated.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-metadata-generated.h"
    COMMAND
      $<TARGET_FILE:quick-lint-js-generate-diagnostic-metadata>
      --output-info-cpp "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-metadata-generated.cpp"
      --output-type-list-h "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-metadata-generated.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-types-2.h"
    DEPENDS
      quick-lint-js-generate-diagnostic-metadata
      "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/diag/diagnostic-types-2.h"
    COMMENT "Generating metadata of diagnostics for diagnostic-metadata-generated.h"
  )
endif ()
# NOTE[generated-target]: We must create a target just for these generated
# files. Otherwise, Ninja's build gets order-only dependencies from
# diagnostic-metadata-generated.h to libquick-lint-js-debug.a, forming a
# dependency cycle (because libquick-lint-js-debug.a depends on
# diagnostic-types.h which depends on diagnostic-metadata-generated.h).
#
# DEPENDS_EXPLICIT_ONLY (CMake 3.27) might fix this, removing the need for an
# intermediate target.
quick_lint_js_add_library(
  quick-lint-js-diagnostic-metadata
  STATIC
  quick-lint-js/diag/diagnostic-metadata-generated.cpp
  quick-lint-js/diag/diagnostic-metadata-generated.h
)
target_include_directories(quick-lint-js-diagnostic-metadata PUBLIC .)
target_link_libraries(
  quick-lint-js-diagnostic-metadata
  PUBLIC
  quick-lint-js-i18n
)
quick_lint_js_target_add_cxx_flag_if_supported(
  quick-lint-js-diagnostic-metadata
  /constexpr:steps9999999
  QUICK_LINT_JS_HAVE_CONSTEXPR_STEPS
)
quick_lint_js_target_add_cxx_flag_if_supported(
  quick-lint-js-diagnostic-metadata
  -fconstexpr-steps=9999999
  QUICK_LINT_JS_HAVE_FCONSTEXPR_STEPS
)

if (TARGET quick-lint-js-generate-lex-keyword)
  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/fe/lex-keyword-generated.cpp"
    COMMAND
      $<TARGET_FILE:quick-lint-js-generate-lex-keyword>
      --output
      "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/fe/lex-keyword-generated.cpp"
    DEPENDS quick-lint-js-generate-lex-keyword
    COMMENT "Generating keyword hash table for lex-keyword-generated.cpp"
  )
endif ()

if (TARGET quick-lint-js-generate-trace-sources)
  add_custom_command(
    OUTPUT
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/debug/public/trace-generated.mjs"
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-metadata-generated.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-reader-generated.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-reader-generated.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-writer-generated.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/../tools/trace.bt"
    COMMAND
      $<TARGET_FILE:quick-lint-js-generate-trace-sources>
      --output-010-editor-template "${CMAKE_CURRENT_SOURCE_DIR}/../tools/trace.bt"
      --output-metadata-cpp "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-metadata-generated.cpp"
      --output-parser-cpp "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-reader-generated.cpp"
      --output-parser-h "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-reader-generated.h"
      --output-parser-js "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/debug/public/trace-generated.mjs"
      --output-writer-h "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-writer-generated.h"
      --trace-types-h "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-types.h"
    DEPENDS
      quick-lint-js-generate-trace-sources
      "${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js/logging/trace-types.h"
    COMMENT "Generating metadata files, parsers, and writers for tracing"
  )
endif ()
# See NOTE[generated-target].
quick_lint_js_add_library(
  quick-lint-js-trace
  STATIC
  quick-lint-js/logging/trace-metadata-generated.cpp
  quick-lint-js/logging/trace-reader-generated.cpp
  quick-lint-js/logging/trace-reader-generated.h
  quick-lint-js/logging/trace-writer-generated.h
)
target_include_directories(quick-lint-js-trace PUBLIC .)
target_link_libraries(quick-lint-js-trace PUBLIC quick-lint-js-tool-lib)

# C++ files which contain QLJS_TRANSLATABLE directives.
set(
  QLJS_TRANSLATION_SOURCES
  ../benchmark/benchmark-translation.cpp
  quick-lint-js/diag/diagnostic-formatter.cpp
  quick-lint-js/diag/diagnostic-metadata-generated.cpp
  quick-lint-js/diag/diagnostic-metadata-generated.h
  ../test/test-diagnostic-formatter.cpp
  ../test/test-vim-qflist-json-diag-reporter.cpp
)

# GNU gettext .po files which contain translation information.
set(
  QLJS_TRANSLATION_FILES
  ../po/de.po
  ../po/en_US@snarky.po
  ../po/fr_FR.po
  ../po/pt_BR.po
  ../po/sv_SE.po
)

if (TARGET quick-lint-js-compile-translations)
  set(COMMAND $<TARGET_FILE:quick-lint-js-compile-translations>)
  set(DEPENDS quick-lint-js-compile-translations)
  set(OUTPUTS)
  set(WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/..")

  macro (add_flag LIST FLAG PATH)
    # Make the output of compile-translations deterministic by using relative
    # paths.
    file(RELATIVE_PATH _PATH "${WORKING_DIRECTORY}" "${CMAKE_CURRENT_SOURCE_DIR}/${PATH}")
    list(APPEND COMMAND "${FLAG}" "${_PATH}")
    list(APPEND "${LIST}" "${CMAKE_CURRENT_SOURCE_DIR}/${PATH}")
  endmacro ()

  foreach (SOURCE IN LISTS QLJS_TRANSLATION_SOURCES)
    add_flag(DEPENDS --source "${SOURCE}")
  endforeach ()
  foreach (TRANSLATION_FILE IN LISTS QLJS_TRANSLATION_FILES)
    add_flag(DEPENDS --po "${TRANSLATION_FILE}")
  endforeach ()
  add_flag(OUTPUTS --output-messages-pot ../po/messages.pot)
  add_flag(OUTPUTS --output-translation-table-cpp quick-lint-js/i18n/translation-table-generated.cpp)
  add_flag(OUTPUTS --output-translation-table-h quick-lint-js/i18n/translation-table-generated.h)
  add_flag(OUTPUTS --output-translation-table-test quick-lint-js/i18n/translation-table-test-generated.h)

  add_custom_command(
    OUTPUT ${OUTPUTS}
    COMMAND ${COMMAND}
    DEPENDS ${DEPENDS}
    COMMENT "Scanning sources for translatable strings and generating translation tables"
    WORKING_DIRECTORY "${WORKING_DIRECTORY}"
  )
endif ()
# See NOTE[generated-target].
quick_lint_js_add_library(
  quick-lint-js-i18n
  STATIC
  quick-lint-js/i18n/translation-table-generated.cpp
  quick-lint-js/i18n/translation-table-generated.h
  quick-lint-js/i18n/translation-table-test-generated.h
)
target_include_directories(quick-lint-js-i18n PUBLIC .)

# These files are needed by some helper tools in addition to the core.
quick_lint_js_add_library(
  quick-lint-js-tool-lib
  quick-lint-js/assert.cpp
  quick-lint-js/assert.h
  quick-lint-js/cli/arg-parser.cpp
  quick-lint-js/cli/arg-parser.h
  quick-lint-js/cli/cli-location.cpp
  quick-lint-js/cli/cli-location.h
  quick-lint-js/container/flexible-array.h
  quick-lint-js/container/linked-bump-allocator.cpp
  quick-lint-js/container/linked-bump-allocator.h
  quick-lint-js/container/padded-string.cpp
  quick-lint-js/container/padded-string.h
  quick-lint-js/container/string-view.h
  quick-lint-js/container/vector-profiler.cpp
  quick-lint-js/container/vector-profiler.h
  quick-lint-js/container/vector.h
  quick-lint-js/container/winkable.h
  quick-lint-js/fe/keyword-lexer.h
  quick-lint-js/fe/keyword-list.h
  quick-lint-js/i18n/po-parser.cpp
  quick-lint-js/i18n/po-parser.h
  quick-lint-js/i18n/translation-table-compiler.cpp
  quick-lint-js/i18n/translation-table-compiler.h
  quick-lint-js/io/file-handle-posix.cpp
  quick-lint-js/io/file-handle-win32.cpp
  quick-lint-js/io/file-handle.h
  quick-lint-js/io/file-path.cpp
  quick-lint-js/io/file-path.h
  quick-lint-js/io/file.cpp
  quick-lint-js/io/file.h
  quick-lint-js/io/io-error.h
  quick-lint-js/io/output-stream.cpp
  quick-lint-js/io/output-stream.h
  quick-lint-js/port/char8.cpp
  quick-lint-js/port/char8.h
  quick-lint-js/port/have.h
  quick-lint-js/port/in-range.h
  quick-lint-js/port/limits.h
  quick-lint-js/port/math.h
  quick-lint-js/port/memory-resource.cpp
  quick-lint-js/port/memory-resource.h
  quick-lint-js/port/source-location.h
  quick-lint-js/port/thread.cpp
  quick-lint-js/port/thread.h
  quick-lint-js/port/type-traits.h
  quick-lint-js/port/warning.h
  quick-lint-js/port/windows-error.cpp
  quick-lint-js/port/windows-error.h
  quick-lint-js/port/windows.h
  quick-lint-js/reflection/cxx-parser.cpp
  quick-lint-js/reflection/cxx-parser.h
  quick-lint-js/util/cast.h
  quick-lint-js/util/enum.h
  quick-lint-js/util/float.cpp
  quick-lint-js/util/float.h
  quick-lint-js/util/integer.cpp
  quick-lint-js/util/integer.h
  quick-lint-js/util/utf-16.cpp
  quick-lint-js/util/utf-16.h
  quick-lint-js/util/utf-8.cpp
  quick-lint-js/util/utf-8.h
)
target_include_directories(quick-lint-js-tool-lib PUBLIC .)
if (WIN32)
  target_link_libraries(quick-lint-js-tool-lib PUBLIC pathcch)
endif ()

quick_lint_js_add_library(
  quick-lint-js-lib
  quick-lint-js/c-api-diag-reporter.cpp
  quick-lint-js/c-api-diag-reporter.h
  quick-lint-js/c-api.cpp
  quick-lint-js/c-api.h
  quick-lint-js/cli/emacs-lisp-diag-reporter.cpp
  quick-lint-js/cli/emacs-lisp-diag-reporter.h
  quick-lint-js/cli/emacs-location.cpp
  quick-lint-js/cli/emacs-location.h
  quick-lint-js/cli/options.cpp
  quick-lint-js/cli/options.h
  quick-lint-js/cli/text-diag-reporter.cpp
  quick-lint-js/cli/text-diag-reporter.h
  quick-lint-js/cli/vim-location.cpp
  quick-lint-js/cli/vim-location.h
  quick-lint-js/cli/vim-qflist-json-diag-reporter.cpp
  quick-lint-js/cli/vim-qflist-json-diag-reporter.h
  quick-lint-js/configuration/basic-configuration-filesystem.cpp
  quick-lint-js/configuration/basic-configuration-filesystem.h
  quick-lint-js/configuration/change-detecting-filesystem-inotify.cpp
  quick-lint-js/configuration/change-detecting-filesystem-kqueue.cpp
  quick-lint-js/configuration/change-detecting-filesystem-win32.cpp
  quick-lint-js/configuration/change-detecting-filesystem.cpp
  quick-lint-js/configuration/change-detecting-filesystem.h
  quick-lint-js/configuration/configuration-loader.cpp
  quick-lint-js/configuration/configuration-loader.h
  quick-lint-js/configuration/configuration.cpp
  quick-lint-js/configuration/configuration.h
  quick-lint-js/container/allocator.h
  quick-lint-js/container/async-byte-queue.cpp
  quick-lint-js/container/async-byte-queue.h
  quick-lint-js/container/byte-buffer.cpp
  quick-lint-js/container/byte-buffer.h
  quick-lint-js/container/c-string-list.h
  quick-lint-js/container/concat.h
  quick-lint-js/container/fixed-vector.h
  quick-lint-js/container/hash-map.h
  quick-lint-js/container/hash-set.h
  quick-lint-js/container/hash.h
  quick-lint-js/container/linked-vector.h
  quick-lint-js/container/optional.h
  quick-lint-js/container/result.h

=== test/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(CheckCXXSourceCompiles)
include(CheckIncludeFileCXX)
include(QuickLintJSCompiler)
include(QuickLintJSTarget)

check_include_file_cxx("libutil.h" QUICK_LINT_JS_HAVE_LIBUTIL_H)
check_include_file_cxx("pty.h" QUICK_LINT_JS_HAVE_PTY_H)
check_include_file_cxx("util.h" QUICK_LINT_JS_HAVE_UTIL_H)

set(FORKPTY_SOURCE "
    int main() {
      pid_t rc = ::forkpty(nullptr, nullptr, nullptr, nullptr);
      return (int)rc;
    }")
if (QUICK_LINT_JS_HAVE_LIBUTIL_H)
  set(FORKPTY_SOURCE "#include <libutil.h>\n${FORKPTY_SOURCE}")
endif ()
if (QUICK_LINT_JS_HAVE_PTY_H)
  set(FORKPTY_SOURCE "#include <pty.h>\n${FORKPTY_SOURCE}")
endif ()
if (QUICK_LINT_JS_HAVE_UTIL_H)
  set(FORKPTY_SOURCE "#include <util.h>\n${FORKPTY_SOURCE}")
endif ()

set(OLD_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
list(APPEND CMAKE_REQUIRED_LIBRARIES util)
check_cxx_source_compiles("${FORKPTY_SOURCE}" QUICK_LINT_JS_HAVE_LIBUTIL)
set(CMAKE_REQUIRED_LIBRARIES "${OLD_CMAKE_REQUIRED_LIBRARIES}")

quick_lint_js_add_library(
  quick-lint-js-test-lib
  quick-lint-js/filesystem-test.cpp
  quick-lint-js/filesystem-test.h
)
target_include_directories(quick-lint-js-test-lib PUBLIC .)
target_link_libraries(
  quick-lint-js-test-lib
  PRIVATE
  gmock
  gtest
  quick-lint-js-lib
  quick-lint-js-lib-debug
)

quick_lint_js_add_executable(
  quick-lint-js-test
  quick-lint-js/array.h
  quick-lint-js/characters.h
  quick-lint-js/diag-matcher.cpp
  quick-lint-js/diag-matcher.h
  quick-lint-js/diagnostic-assertion.cpp
  quick-lint-js/diagnostic-assertion.h
  quick-lint-js/dirty-set.h
  quick-lint-js/failing-diag-reporter.cpp
  quick-lint-js/failing-diag-reporter.h
  quick-lint-js/fake-configuration-filesystem.cpp
  quick-lint-js/file-matcher.h
  quick-lint-js/gtest.h
  quick-lint-js/mock-inotify.h
  quick-lint-js/mock-kqueue.h
  quick-lint-js/mock-win32.h
  quick-lint-js/parse-support.cpp
  quick-lint-js/parse-support.h
  quick-lint-js/spy-lsp-endpoint-remote.h
  quick-lint-js/spy-lsp-message-parser.h
  quick-lint-js/spy-visitor.cpp
  quick-lint-js/spy-visitor.h
  quick-lint-js/tjson.cpp
  quick-lint-js/tjson.h
  quick-lint-js/tracking-memory-resource.h
  quick-lint-js/variable-analyzer-support.cpp
  quick-lint-js/variable-analyzer-support.h
  test-array.cpp
  test-assert.cpp
  test-async-byte-queue.cpp
  test-bit.cpp
  test-buffering-visitor-stack.cpp
  test-buffering-visitor.cpp
  test-byte-buffer.cpp
  test-c-api.cpp
  test-c-string-list.cpp
  test-cli-location.cpp
  test-concat.cpp
  test-configuration-loader.cpp
  test-configuration.cpp
  test-crash.cpp
  test-cxx-parser.cpp
  test-debug-server.cpp
  test-diag-code-list.cpp
  test-diag-list.cpp
  test-diagnostic-assertion.cpp
  test-diagnostic-formatter.cpp
  test-diagnostic.cpp
  test-dirty-set.cpp
  test-emacs-lisp-diag-reporter.cpp
  test-emacs-location.cpp
  test-event-loop.cpp
  test-file-canonical.cpp
  test-file-path.cpp
  test-file.cpp
  test-fixed-vector.cpp
  test-flexible-array.cpp
  test-function-ref.cpp
  test-instance-tracker.cpp
  test-integer-decimal.cpp
  test-integer-hexadecimal.cpp
  test-json.cpp
  test-lex.cpp
  test-linked-bump-allocator.cpp
  test-linked-vector.cpp
  test-locale.cpp
  test-lsp-diag-reporter.cpp
  test-lsp-document-text.cpp
  test-lsp-json-rpc-message-parser.cpp
  test-lsp-language.cpp
  test-lsp-location.cpp
  test-lsp-message-parser.cpp
  test-lsp-pipe-writer.cpp
  test-lsp-server.cpp
  test-lsp-uri.cpp
  test-lsp-workspace-configuration.cpp
  test-math-overflow.cpp
  test-narrow-cast.cpp
  test-options.cpp
  test-output-stream.cpp
  test-padded-string.cpp
  test-parse-class.cpp
  test-parse-conditional-expression.cpp
  test-parse-decorator.cpp
  test-parse-expression-jsx.cpp
  test-parse-expression-statement.cpp
  test-parse-expression-typescript.cpp
  test-parse-expression.cpp
  test-parse-function.cpp
  test-parse-jsx-react.cpp
  test-parse-jsx.cpp
  test-parse-loop.cpp
  test-parse-module.cpp
  test-parse-statement.cpp
  test-parse-typescript-ambiguous.cpp
  test-parse-typescript-angle-type-assertion.cpp
  test-parse-typescript-class-overload.cpp
  test-parse-typescript-class.cpp
  test-parse-typescript-declare-class.cpp
  test-parse-typescript-declare-function.cpp
  test-parse-typescript-declare-global.cpp
  test-parse-typescript-declare-interface.cpp
  test-parse-typescript-declare-module.cpp
  test-parse-typescript-declare-namespace.cpp
  test-parse-typescript-declare-tsmodule.cpp
  test-parse-typescript-declare-type-alias.cpp
  test-parse-typescript-declare-var.cpp
  test-parse-typescript-definition.cpp
  test-parse-typescript-enum.cpp
  test-parse-typescript-export-declare.cpp
  test-parse-typescript-function-overload.cpp
  test-parse-typescript-function.cpp
  test-parse-typescript-generic-arrow.cpp
  test-parse-typescript-generic.cpp
  test-parse-typescript-interface.cpp
  test-parse-typescript-module.cpp
  test-parse-typescript-namespace.cpp
  test-parse-typescript-object-type.cpp
  test-parse-typescript-object.cpp
  test-parse-typescript-statement.cpp
  test-parse-typescript-this-parameters.cpp
  test-parse-typescript-type-alias.cpp
  test-parse-typescript-type.cpp
  test-parse-typescript-var.cpp
  test-parse-typescript.cpp
  test-parse-var.cpp
  test-parse-warning.cpp
  test-parse.cpp
  test-pipe-writer.cpp
  test-po-parser.cpp
  test-pointer.cpp
  test-pty.cpp
  test-result.cpp
  test-simd.cpp
  test-sorted-search.cpp
  test-string-view.cpp
  test-temporary-directory.cpp
  test-text-diag-reporter.cpp
  test-thread.cpp
  test-tjson.cpp
  test-trace-flusher.cpp
  test-trace-reader-writer.cpp
  test-trace-reader.cpp
  test-trace-writer.cpp
  test-tracking-memory-resource.cpp
  test-translation-table-compiler.cpp
  test-translation.cpp
  test-try-catch-stack.cpp
  test-typescript-test.cpp
  test-utf-16.cpp
  test-utf-8.cpp
  test-variable-analyzer-arguments.cpp
  test-variable-analyzer-assign.cpp
  test-variable-analyzer-class.cpp
  test-variable-analyzer-declare.cpp
  test-variable-analyzer-delete.cpp
  test-variable-analyzer-enum.cpp
  test-variable-analyzer-eval.cpp
  test-variable-analyzer-globals.cpp
  test-variable-analyzer-interface.cpp
  test-variable-analyzer-module.cpp
  test-variable-analyzer-multiple-declarations.cpp
  test-variable-analyzer-namespace.cpp
  test-variable-analyzer-parse.cpp
  test-variable-analyzer-type.cpp
  test-variable-analyzer-typeof.cpp
  test-variable-analyzer-unused-shadow.cpp
  test-variable-analyzer.cpp
  test-vector-profiler.cpp
  test-vector.cpp
  test-vim-location.cpp
  test-vim-qflist-json-diag-reporter.cpp
  test-vscode-language.cpp
  test-web-demo-location.cpp
  test-write-float.cpp
  test-write-integer.cpp
)
target_include_directories(quick-lint-js-test PRIVATE .)
target_link_libraries(
  quick-lint-js-test
  PRIVATE
  gmock
  gmock_main
  gtest
  quick-lint-js-i18n
  quick-lint-js-lib
  quick-lint-js-lib-debug
  quick-lint-js-test-lib
  quick-lint-js-typescript-test-lib
)
if (WIN32)
  target_link_libraries(quick-lint-js-test PRIVATE wsock32 ws2_32)
endif ()
if (QUICK_LINT_JS_FEATURE_DEBUG_SERVER)
  target_link_libraries(quick-lint-js-test PRIVATE mongoose)
endif ()
if (QUICK_LINT_JS_HAVE_LIBUTIL)
  target_link_libraries(quick-lint-js-test PRIVATE util)
endif ()
if (QUICK_LINT_JS_PRECOMPILE_HEADERS)
  target_precompile_headers(
    quick-lint-js-test
    PRIVATE
    <gmock/gmock.h>
    <gtest/gtest.h>
    <iostream>
    <simdjson.h>
  )
endif ()
quick_lint_js_enable_bigobj_if_supported(quick-lint-js-test)

set_source_files_properties(
  quick-lint-js/diagnostic-assertion.cpp
  PROPERTIES
  COMPILE_DEFINITIONS
  QLJS_DIAGNOSTIC_TYPES_H_FILE_PATH=\"${CMAKE_CURRENT_SOURCE_DIR}/../src/quick-lint-js/diag/diagnostic-types-2.h\"
)

# HACK(strager): LTO builds are very slow. Our tests don't
# *need* LTO optimizations. Disable LTO for our tests.
set_target_properties(
  quick-lint-js-test
  PROPERTIES
  INTERPROCEDURAL_OPTIMIZATION OFF
)

add_test(
  NAME quick-lint-js-test
  COMMAND quick-lint-js-test
)

# Disable MSVC warnings in googletest's headers.
# TODO(strager): Use MSVC's /external switches instead.
quick_lint_js_add_warning_options_if_supported(
  quick-lint-js-test
  PRIVATE
  /wd26495 # Always initialize a member variable
  /wd26812 # Prefer 'enum class' over 'enum'
)

# HACK(strager): UndefinedBehaviorSanitizer is buggy on Linux x86_64 with GCC
# 8.4.0. Disable some UBSAN checks to avoid false positives.
if (
  CMAKE_CXX_COMPILER_ID STREQUAL GNU
  AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0.0
)
  set_source_files_properties(
    test-lex.cpp
    PROPERTIES
    COMPILE_OPTIONS -fno-sanitize=null
  )
endif ()

find_package(ICU COMPONENTS uc)
if (ICU_FOUND)
  quick_lint_js_add_executable(
    quick-lint-js-test-lex-unicode
    test-lex-unicode.cpp
  )
  target_link_libraries(
    quick-lint-js-test-lex-unicode
    PRIVATE
    ICU::uc
    gmock
    gmock_main
    gtest
    quick-lint-js-lib
  )
  if (QUICK_LINT_JS_PRECOMPILE_HEADERS)
    target_precompile_headers(
      quick-lint-js-test-lex-unicode
      PRIVATE
      <gmock/gmock.h>
      <gtest/gtest.h>
    )
  endif ()

  add_test(
    NAME quick-lint-js-test-lex-unicode
    COMMAND quick-lint-js-test-lex-unicode
  )
endif ()

if (TARGET quick-lint-js)
  quick_lint_js_add_executable(
    quick-lint-js-test-cli
    test-cli.cpp
  )
  target_link_libraries(
    quick-lint-js-test-cli
    PRIVATE
    gmock
    gmock_main
    gtest
    quick-lint-js-lib
    quick-lint-js-lib-debug
    quick-lint-js-test-lib
  )
  if (QUICK_LINT_JS_HAVE_LIBUTIL)
    target_link_libraries(quick-lint-js-test-cli PRIVATE util)
  endif ()
  add_dependencies(quick-lint-js-test-cli quick-lint-js)
  add_test(
    NAME quick-lint-js-test-cli
    COMMAND quick-lint-js-test-cli
  )
  set_property(
    TEST quick-lint-js-test-cli
    APPEND PROPERTY ENVIRONMENT QUICK_LINT_JS_EXE=$<TARGET_FILE:quick-lint-js>
  )
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== tools/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(GNUInstallDirs)
include(QuickLintJSTarget)

add_subdirectory(test-typescript)

if (NOT EMSCRIPTEN) # We don't support tools targeting Emscripten.
  quick_lint_js_add_executable(quick-lint-js-analyze-trace analyze-trace.cpp)
  target_link_libraries(
    quick-lint-js-analyze-trace
    PRIVATE
    quick-lint-js-lib
  )
endif ()

set(QUICK_LINT_JS_BUILD_TOOL_EXECUTABLE_SUFFIX "")
if (CMAKE_HOST_SYSTEM_NAME STREQUAL Windows)
  set(QUICK_LINT_JS_BUILD_TOOL_EXECUTABLE_SUFFIX .exe)
endif ()

set(QUICK_LINT_JS_BUILD_TOOL_TARGETS)
function (quick_lint_js_add_build_tool_executable NAME)
  set(SOURCES "${ARGN}")
  if (QUICK_LINT_JS_USE_BUILD_TOOLS)
    add_executable("${NAME}" IMPORTED GLOBAL)
    set_target_properties(
      "${NAME}"
      PROPERTIES
      IMPORTED_LOCATION "${QUICK_LINT_JS_USE_BUILD_TOOLS}/${NAME}${QUICK_LINT_JS_BUILD_TOOL_EXECUTABLE_SUFFIX}"
    )
  elseif (QUICK_LINT_JS_ENABLE_BUILD_TOOLS)
    quick_lint_js_add_executable("${NAME}" ${SOURCES})
    set_target_properties("${NAME}" PROPERTIES RUNTIME_OUTPUT_DIRECTORY ..)
    target_link_libraries("${NAME}" PRIVATE quick-lint-js-tool-lib)
    target_include_directories("${NAME}" PRIVATE .)
  endif ()

  list(APPEND QUICK_LINT_JS_BUILD_TOOL_TARGETS "${NAME}")
  set(QUICK_LINT_JS_BUILD_TOOL_TARGETS "${QUICK_LINT_JS_BUILD_TOOL_TARGETS}" PARENT_SCOPE)
endfunction ()

quick_lint_js_add_build_tool_executable(
  quick-lint-js-compile-translations
  compile-translations.cpp
)

quick_lint_js_add_build_tool_executable(
  quick-lint-js-generate-diagnostic-metadata
  generate-diagnostic-metadata.cpp
)

quick_lint_js_add_build_tool_executable(
  quick-lint-js-generate-lex-keyword
  generate-lex-keyword.cpp
)

quick_lint_js_add_build_tool_executable(
  quick-lint-js-generate-trace-sources
  generate-trace-sources.cpp
)

if (QUICK_LINT_JS_ENABLE_BUILD_TOOLS)
  add_custom_target(
    quick-lint-js-build-tools
    COMMENT "Building all quick-lint-js build-time tools"
    DEPENDS ${QUICK_LINT_JS_BUILD_TOOL_TARGETS}
  )
  install(
    TARGETS ${QUICK_LINT_JS_BUILD_TOOL_TARGETS}
    COMPONENT build-tools
    EXCLUDE_FROM_ALL
    RUNTIME
    DESTINATION "${CMAKE_INSTALL_BINDIR}"
  )
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== benchmark/benchmark-lsp/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(CheckCXXSourceCompiles)
include(CheckIncludeFileCXX)
include(QuickLintJSTarget)

check_include_file_cxx(
  coroutine
  QUICK_LINT_JS_HAVE_COROUTINE
)
check_cxx_source_compiles(
  "#include <filesystem>
int main() {
  return std::filesystem::path(u8\"hello\").empty() ? 2 : 0;
}"
  QUICK_LINT_JS_HAVE_FILESYSTEM_CHAR8
)
if (
  QUICK_LINT_JS_HAVE_COROUTINE AND
  QUICK_LINT_JS_HAVE_FILESYSTEM_CHAR8 AND
  NOT EMSCRIPTEN AND  # We don't support Emscripten.
  NOT WIN32  # We don't support Windows yet.
)
  quick_lint_js_add_executable(
    quick-lint-js-benchmark-lsp-servers
    benchmark-config.cpp
    lsp-benchmarks.cpp
    lsp-server-process.cpp
    main.cpp
    process.cpp
    quick-lint-js/benchmark-config.h
    quick-lint-js/lsp-benchmarks.h
    quick-lint-js/lsp-logging.h
    quick-lint-js/lsp-server-process.h
    quick-lint-js/process.h
  )
  target_link_libraries(
    quick-lint-js-benchmark-lsp-servers
    PRIVATE
    quick-lint-js-lib
    simdjson
  )
  target_include_directories(quick-lint-js-benchmark-lsp-servers PRIVATE .)
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== plugin/emacs/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(GNUInstallDirs)

install(
  FILES
    flycheck-quicklintjs.el
    lsp-quicklintjs.el
    eglot-quicklintjs.el
    flymake-quicklintjs.el
  DESTINATION "${QUICK_LINT_JS_INSTALL_EMACS_DIR}"
)

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== plugin/vim/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.13)
include(GNUInstallDirs)

set(
  VIM_FILES
  ale_linters/javascript/quick_lint_js.vim
  autoload/quick_lint_js_ale.vim
  doc/quick-lint-js.txt
  plugin/quick-lint-js.vim
)
if (QUICK_LINT_JS_INSTALL_VIM_NEOVIM_TAGS)
  list(APPEND VIM_FILES doc/tags)
endif ()
foreach (FILE IN LISTS VIM_FILES)
  get_filename_component(DIR "${FILE}" DIRECTORY)
  install(
    FILES "quick-lint-js.vim/${FILE}"
    DESTINATION "${QUICK_LINT_JS_INSTALL_VIM_DIR}/${DIR}"
  )
endforeach ()

set(
  NEOVIM_FILES
  ${VIM_FILES}
  lua/lspconfig/quick_lint_js.lua
  lua/quick-lint-js.lua
)
foreach (FILE IN LISTS NEOVIM_FILES)
  get_filename_component(DIR "${FILE}" DIRECTORY)
  install(
    FILES "quick-lint-js.vim/${FILE}"
    DESTINATION "${QUICK_LINT_JS_INSTALL_NEOVIM_DIR}/${DIR}"
  )
endforeach ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== dist/debian/debian/changelog ===
quick-lint-js (3.2.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Sun, 03 Mar 2024 23:36:12 -0500

quick-lint-js (3.1.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 10 Jan 2024 21:40:21 -0500

quick-lint-js (3.0.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 01 Jan 2024 02:11:59 -0500

quick-lint-js (2.19.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Sat, 30 Dec 2023 01:40:27 -0500

quick-lint-js (2.18.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Fri, 03 Nov 2023 17:41:59 -0400

quick-lint-js (2.17.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 25 Oct 2023 19:42:44 -0400

quick-lint-js (2.16.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 06 Sep 2023 22:13:52 -0700

quick-lint-js (2.15.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Tue, 18 Jul 2023 18:58:52 -0700

quick-lint-js (2.14.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 22 May 2023 19:49:21 -0700

quick-lint-js (2.13.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Thu, 13 Apr 2023 16:33:56 -0700

quick-lint-js (2.12.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 08 Mar 2023 16:06:59 -0800

quick-lint-js (2.11.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Tue, 31 Jan 2023 16:27:10 -0800

quick-lint-js (2.10.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Fri, 14 Oct 2022 17:56:06 -0700

quick-lint-js (2.9.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 05 Sep 2022 18:02:20 -0700

quick-lint-js (2.8.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 25 Jul 2022 15:07:29 -0700

quick-lint-js (2.7.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 13 Jul 2022 14:32:01 -0700

quick-lint-js (2.6.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 15 Jun 2022 17:18:56 -0700

quick-lint-js (2.5.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 23 May 2022 14:22:17 -0700

quick-lint-js (2.4.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1009937)

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 27 Apr 2022 16:54:50 -0700

=== dist/debian/debian/control ===
Source: quick-lint-js
Section: devel
Priority: optional
Maintainer: Matthew "strager" Glazar <strager.nds@gmail.com>
Build-Depends: debhelper (>= 12), cmake (>= 3.10), libgmock-dev, libgtest-dev, libsimdjson-dev, pkg-config
Standards-Version: 4.6.0.1
Homepage: https://quick-lint-js.com/
Vcs-Browser: https://github.com/quick-lint/quick-lint-js
Vcs-Git: https://github.com/quick-lint/quick-lint-js.git

Package: quick-lint-js
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: JavaScript linter
 quick-lint-js finds bugs in your JavaScript code. This package includes the
 CLI and LSP server.

Package: quick-lint-js-vim
Architecture: all
Depends: ${misc:Depends}, quick-lint-js, vim, vim-addon-manager
Description: Vim and Neovim plugin for quick-lint-js
 quick-lint-js finds bugs in your JavaScript code. This plugin uses
 quick-lint-js to highlight errors in your editor.

=== dist/debian/debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# HACK(strager): googletest was compiled without -fchar8_t (default for
# -std=c++20). It is missing symbols which might be referenced if quick-lint-js
# is built with -fchar8_t. Tell quick-lint-js' build system that -fchar8_t
# exists (QUICK_LINT_JS_HAVE_FCHAR8_T_FLAG=YES) but doesn't work
# (QUICK_LINT_JS_HAVE_WORKING_FCHAR8_T=NO), causing it to build with
# -fno-char8_t. This fixes undefined symbol errors when linking tests.
override_dh_auto_configure:
	dh_auto_configure -- \
		-DQUICK_LINT_JS_HAVE_FCHAR8_T_FLAG=YES \
		-DQUICK_LINT_JS_HAVE_WORKING_FCHAR8_T=NO \
		-DQUICK_LINT_JS_INSTALL_EMACS_DIR=share/emacs/site-lisp/quick-lint-js \
		-DQUICK_LINT_JS_INSTALL_VIM_DIR=share/vim/addons \
		-DQUICK_LINT_JS_INSTALL_VIM_NEOVIM_TAGS=ON \
		-DQUICK_LINT_JS_USE_BUNDLED_GOOGLE_BENCHMARK=NO \
		-DQUICK_LINT_JS_USE_BUNDLED_GOOGLE_TEST=NO \
		-DQUICK_LINT_JS_USE_BUNDLED_SIMDJSON=NO \
		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=YES

override_dh_auto_install:
	dh_auto_install
	install -m644 -D \
		plugin/vim/quick-lint-js.yaml \
		debian/tmp/usr/share/vim/registry/quick-lint-js.yaml

=== dist/debian/debian/watch ===
version=4

opts="pgpmode=next" https://c.quick-lint-js.com/releases/latest/source/ quick-lint-js-@ANY_VERSION@@ARCHIVE_EXT@ debian
opts="pgpmode=previous" https://c.quick-lint-js.com/releases/latest/source/ quick-lint-js-@ANY_VERSION@@SIGNATURE_EXT@ previous
